# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""
Python bindings to DLite


"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _dlite
else:
    import _dlite

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)



def _get_storage_base() -> "PyObject *":
    return _dlite._get_storage_base()

def _get_mapping_base() -> "PyObject *":
    return _dlite._get_mapping_base()

def _get_DLiteError() -> "PyObject *":
    return _dlite._get_DLiteError()

DLiteError = _dlite._get_DLiteError()
DLiteStorageBase = _dlite._get_storage_base()
DLiteMappingBase = _dlite._get_mapping_base()


def get_version() -> "char const *":
    r"""
    get_version() -> char const *
    Returns the current version of DLite.

    """
    return _dlite.get_version()

def get_license() -> "char const *":
    r"""
    get_license() -> char const *
    Returns DLite licenses information.

    """
    return _dlite.get_license()

def get_uuid(id: "char const *"=None) -> "char *":
    r"""
    get_uuid(id=None)
    Returns an UUID, depending on:
      - If `id` is NULL or empty, generates a new random version 4 UUID.
      - If `id` is not a valid UUID string, generates a new version 5 sha1-based
        UUID from `id` using the DNS namespace.
      - Otherwise return `id` (which already must be a valid UUID).

    """
    return _dlite.get_uuid(id)

def get_uuid_version(id: "char const *"=None) -> "posstatus_t":
    r"""
    get_uuid_version(id=None) -> posstatus_t
    Returns the generated UUID version number if `id` had been passed to
    get_uuid() or zero if `id` is already a valid UUID.

    """
    return _dlite.get_uuid_version(id)

def join_meta_uri(name: "char const *", version: "char const *", namespace: "char const *") -> "char *":
    r"""
    join_meta_uri(name, version, namespace) -> char *
    Returns a (metadata) uri by combining `name`, `version` and `namespace` as:

        namespace/version/name

    """
    return _dlite.join_meta_uri(name, version, namespace)

def split_meta_uri(uri: "char const *") -> "char **, char **, char **":
    r"""
    split_meta_uri(uri) -> status_t
    Returns (name, version, namespace)-tuplet from valid metadata `uri`.

    """
    return _dlite.split_meta_uri(uri)

def join_url(driver: "char const *", location: "char const *", options: "char const *"=None, fragment: "char const *"=None) -> "char *":
    r"""
    join_url(driver, location, options=None, fragment=None) -> char *
    Returns an url constructed from the arguments of the form:

        driver://location?options#fragment

    The `driver`, `options` and `fragment` arguments may be None.

    """
    return _dlite.join_url(driver, location, options, fragment)

def split_url(url: "char *") -> "char **, char **, char **, char **":
    r"""
    split_url(url) -> status_t
    Returns a (driver, location, options, fragment)-tuplet by splitting
    `url` of the form

        driver://location?options#fragment

    into four parts.

    """
    return _dlite.split_url(url)

def globmatch(pattern: "char const *", s: "char const *") -> "int":
    r"""
    globmatch(pattern, s) -> int
    Match string 's' against glob pattern 'pattern' and return zero on
    match.

    Understands the following patterns:
         *       any number of characters
         ?       any single character
         [a-z]   any single character in the range a-z
         [^a-z]  any single character not in the range a-z

    """
    return _dlite.globmatch(pattern, s)

def errclr() -> "void":
    r"""
    errclr()
    Clear the last error (setting its error code to zero).

    """
    return _dlite.errclr()

def errval() -> "int":
    r"""
    errval() -> int
    Returns the error code (error value) or the last error or zero if no errors
    have occured since the last call to dlite.errclr().

    """
    return _dlite.errval()

def errmsg() -> "char const *":
    r"""
    errmsg() -> char const *
    Returns the error message of the last error.  None is returned if no errors
    have occured since the last call to dlite.errclr().

    """
    return _dlite.errmsg()

def err_get_stream() -> "FILE *":
    r"""err_get_stream() -> FILE *"""
    return _dlite.err_get_stream()

def err_set_stream(arg1: "FILE *") -> "void":
    r"""err_set_stream(arg1)"""
    return _dlite.err_set_stream(arg1)

def err_set_file(filename: "char const *") -> "void":
    r"""
    err_set_file(filename)
    Set error log file.  Special values includes:
      - None | : turn off error output
      - <stderr>:  standard error
      - <stdout>:  standard output
    All other values are treated as a filename that will be opened in append mode.

    """
    return _dlite.err_set_file(filename)

def asbool(str: "char const *") -> "bool":
    r"""
    asbool(str) -> bool
    Set error stream.

    """
    return _dlite.asbool(str)

import dlite

class err():
    """Context manager for temporary turning off or redirecting errors.

    By default errors are skipped within the err context.  But if
    `filename` is provided, the error messages are written to that file.
    Special file names includes
      - None or empty: no output is written
      - <stderr>: write errors to stderr (default)
      - <stdout>: write errors to stdout
    """
    def __init__(self, filename=None):
        self.filename = filename

    def __enter__(self):
        self.f = dlite.err_get_stream()
        dlite.err_set_file(self.filename)
        return self.f

    def __exit__(self, *exc):
        dlite.errclr()
        dlite.err_set_stream(self.f)

silent = err()

BlobType = _dlite.BlobType

BoolType = _dlite.BoolType

IntType = _dlite.IntType

UIntType = _dlite.UIntType

FloatType = _dlite.FloatType

FixStringType = _dlite.FixStringType

StringPtrType = _dlite.StringPtrType

DimensionType = _dlite.DimensionType

PropertyType = _dlite.PropertyType

RelationType = _dlite.RelationType


def from_typename(typename: "char const *") -> "int *, int *":
    r"""from_typename(typename) -> status_t"""
    return _dlite.from_typename(typename)

def to_typename(type: "int", size: "int") -> "char *":
    r"""to_typename(type, size) -> char *"""
    return _dlite.to_typename(type, size)

def get_alignment(type: "int", size: "size_t") -> "size_t":
    r"""get_alignment(type, size) -> size_t"""
    return _dlite.get_alignment(type, size)
class StorageIterator(object):
    r"""
    Iterates over instances in storage `s`.  If `pattern` is given, only
    instances whos metadata URI matches `pattern` are returned.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    s = property(_dlite.StorageIterator_s_get, _dlite.StorageIterator_s_set, doc=r"""s""")
    state = property(_dlite.StorageIterator_state_get, _dlite.StorageIterator_state_set, doc=r"""state""")

    def __init__(self, s: "Storage", pattern: "char const *"=None):
        r"""
        __init__(self, s, pattern=None) -> StorageIterator
        Iterates over instances in storage `s`.  If `pattern` is given, only
        instances whos metadata URI matches `pattern` are returned.

        """
        _dlite.StorageIterator_swiginit(self, _dlite.new_StorageIterator(s, pattern))
    __swig_destroy__ = _dlite.delete_StorageIterator

    def next(self) -> "struct _DLiteInstance *":
        r"""
        next(self) -> Instance
        Returns next instance or None if exhausted.
        """
        return _dlite.StorageIterator_next(self)

    def __iter__(self) -> "struct StorageIterator *":
        r"""__iter__(self) -> StorageIterator"""
        return _dlite.StorageIterator___iter__(self)

    def __next__(self):
        inst = self.next()
        if not inst:
            raise StopIteration()
        return inst


# Register StorageIterator in _dlite:
_dlite.StorageIterator_swigregister(StorageIterator)

IDTranslateToUUID = _dlite.IDTranslateToUUID

IDRequireUUID = _dlite.IDRequireUUID

IDKeepID = _dlite.IDKeepID

class Storage(object):
    r"""
    Represents a data storage.

    Parameters
    ----------
    driver_or_url : string
        Name of driver used to connect to the storage or, if `location` is not
        given, the URL to the storage:

            driver://location?options

    location : string
        The location to the storage.  For file storages, this is the file name.
    options : string
        Additional options passed to the driver as a list of semicolon-separated
        ``key=value`` pairs.  Each driver may have their own options.  Some
        common options are:
          - mode={'append','r','w'}: 'append': append to existing storage or
            create a new one (hdf5,json).
          - compact={'yes','no'}: Whether to store in a compact format (json).
          - meta={'yes','no'}: Whether to format output as metadata (json).

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    location = property(_dlite.Storage_location_get, doc=r"""location""")
    options = property(_dlite.Storage_options_get, doc=r"""options""")
    flags = property(_dlite.Storage_flags_get, doc=r"""flags""")
    idflag = property(_dlite.Storage_idflag_get, doc=r"""idflag""")

    def __init__(self, driver_or_url: "char const *", location: "char const *"=None, options: "char const *"=None):
        r"""
        __init__(self, driver_or_url, location=None, options=None) -> Storage
        Represents a data storage.

        Parameters
        ----------
        driver_or_url : string
            Name of driver used to connect to the storage or, if `location` is not
            given, the URL to the storage:

                driver://location?options

        location : string
            The location to the storage.  For file storages, this is the file name.
        options : string
            Additional options passed to the driver as a list of semicolon-separated
            ``key=value`` pairs.  Each driver may have their own options.  Some
            common options are:
              - mode={'append','r','w'}: 'append': append to existing storage or
                create a new one (hdf5,json).
              - compact={'yes','no'}: Whether to store in a compact format (json).
              - meta={'yes','no'}: Whether to format output as metadata (json).

        """
        _dlite.Storage_swiginit(self, _dlite.new_Storage(driver_or_url, location, options))
    __swig_destroy__ = _dlite.delete_Storage

    def get_driver(self) -> "char const *":
        r"""
        get_driver(self) -> char const *
        Returns name of driver for this storage.
        """
        return _dlite.Storage_get_driver(self)

    def get_uuids(self, pattern: "char const *"=None) -> "char **":
        r"""
        get_uuids(self, pattern=None) -> char **
        Returns a list of UUIDs of all instances in the storage whos metadata
        matches `pattern`.  If `pattern` is None, all UUIDs will be returned.

        """
        return _dlite.Storage_get_uuids(self, pattern)

    def _get_readable(self) -> "bool":
        r"""
        _get_readable(self) -> bool
        Returns whether the storage is readable.
        """
        return _dlite.Storage__get_readable(self)

    def _set_readable(self, readable: "bool") -> "void":
        r"""
        _set_readable(self, readable)
        Set storage readability.
        """
        return _dlite.Storage__set_readable(self, readable)

    def _get_writable(self) -> "bool":
        r"""
        _get_writable(self) -> bool
        Returns whether the storage is writable.
        """
        return _dlite.Storage__get_writable(self)

    def _set_writable(self, writable: "bool") -> "void":
        r"""
        _set_writable(self, writable)
        Set storage writability.
        """
        return _dlite.Storage__set_writable(self, writable)

    def _get_generic(self) -> "bool":
        r"""
        _get_generic(self) -> bool
        Returns whether the storage is generic.
        """
        return _dlite.Storage__get_generic(self)

    def _set_generic(self, generic: "bool") -> "void":
        r"""
        _set_generic(self, generic)
        Set whether storage is generic
        """
        return _dlite.Storage__set_generic(self, generic)

          # Override default __init__()
    def __init__(self, driver_or_url, location=None, options=None):
        loc = str(location) if location else None
        _dlite.Instance_swiginit(self, _dlite.new_Storage(
            driver_or_url=driver_or_url, location=loc, options=options))

    def __enter__(self):
        return self

    def __exit__(self, *exc):
        del self.this

    def __repr__(self):
        return (
            f"Storage('{self.driver}', location='{self.location}', "
            f"options='{self.options}')"
        )

    def __iter__(self):
        return StorageIterator(self)

    readable = property(
        fget=lambda self: self._get_readable(),
        doc="Whether the storage is readable.")

    writable = property(
        fget=lambda self: self._get_writable(),
        doc="Whether the storage is writable.")

    generic = property(
        fget=lambda self: self._get_generic(),
        doc="Whether the storage is generic, i.e. whether the storage can "
        "hold multiple instances, including both data and metadata."
    )

    @classmethod
    def create_from_url(cls, url):
        """Create a new storage from `url`."""
        return cls(url)

    def instances(self, pattern=None):
        """Returns an iterator over all instances in storage whos
        metadata URI matches `pattern`."""
        return StorageIterator(self, pattern=pattern)

    def load(self, id, metaid=None):
        """Loads instance `id` from this storage and return it.

        If `metaid` is provided, the returned instance will be
        mapped to an instance of this type (if appropriate mappings
        are available)."""
        return Instance.from_storage(self, id, metaid)

    def save(self, inst):
        """Stores instance `inst` in this storage."""
        inst.save_to_storage(self)

    driver = property(get_driver,
                      doc='Name of driver associated with this storage')


# Register Storage in _dlite:
_dlite.Storage_swigregister(Storage)

class StoragePluginIter(object):
    r"""
    Iterates over loaded storage plugins.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    iter = property(_dlite.StoragePluginIter_iter_get, _dlite.StoragePluginIter_iter_set, doc=r"""iter""")

    def __init__(self):
        r"""
        __init__(self) -> StoragePluginIter
        Iterates over loaded storage plugins.

        """
        _dlite.StoragePluginIter_swiginit(self, _dlite.new_StoragePluginIter())
    __swig_destroy__ = _dlite.delete_StoragePluginIter

    def next(self) -> "char const *":
        r"""
        next(self) -> char const *
        Returns name of next plugin or None if exhausted.

        """
        return _dlite.StoragePluginIter_next(self)

    def __iter__(self) -> "struct StoragePluginIter *":
        r"""__iter__(self) -> StoragePluginIter"""
        return _dlite.StoragePluginIter___iter__(self)

    def __next__(self):
        name = self.next()
        if not name:
            raise StopIteration()
        return name


# Register StoragePluginIter in _dlite:
_dlite.StoragePluginIter_swigregister(StoragePluginIter)


def storage_unload(name: "char const *") -> "int":
    r"""storage_unload(name) -> int"""
    return _dlite.storage_unload(name)
class Dimension(object):
    r"""Proxy of C _DLiteDimension struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_dlite.Dimension_name_get, _dlite.Dimension_name_set, doc=r"""name""")
    description = property(_dlite.Dimension_description_get, _dlite.Dimension_description_set, doc=r"""description""")

    def __init__(self, name: "char const *", description: "char const *"=None):
        r"""__init__(self, name, description=None) -> Dimension"""
        _dlite.Dimension_swiginit(self, _dlite.new_Dimension(name, description))
    __swig_destroy__ = _dlite.delete_Dimension

    def __repr__(self):
        return 'Dimension(name=%r, description=%r)' % (
            self.name, self.description)

    def asdict(self):
        """Returns a dict representation of self."""
        d = OrderedDict()
        d['name'] = self.name
        if self.description:
            d['description'] = self.description
        return d

    def asstrings(self):
        """Returns a representation of self as a tuple of strings."""
        return (self.name,
                '' if self.description is None else self.description)


# Register Dimension in _dlite:
_dlite.Dimension_swigregister(Dimension)

class Property(object):
    r"""
    Creates a new property.

    Property(name, type, dims=None, unit=None, description=None)
        Creates a new property with the provided attributes.

    Property(seq)
        Creates a new property from sequence of 6 strings, corresponding to
        `name`, `type`, `dims`, `unit` and `description`.  Valid
        values for `dims` are:
          - '' or '[]': no dimensions
          - '<dim1>, <dim2>': list of dimension names
          - '[<dim1>, <dim2>]': list of dimension names


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    name = property(_dlite.Property_name_get, _dlite.Property_name_set, doc=r"""name""")
    size = property(_dlite.Property_size_get, _dlite.Property_size_set, doc=r"""size""")
    ref = property(_dlite.Property_ref_get, _dlite.Property_ref_set, doc=r"""ref""")
    ndims = property(_dlite.Property_ndims_get, doc=r"""ndims""")
    unit = property(_dlite.Property_unit_get, _dlite.Property_unit_set, doc=r"""unit""")
    description = property(_dlite.Property_description_get, _dlite.Property_description_set, doc=r"""description""")

    def __init__(self, name: "char const *", type: "char const *", dims: "obj_t *"=None, unit: "char const *"=None, description: "char const *"=None):
        r"""
        __init__(self, name, type, dims=None, unit=None, description=None) -> Property
        Creates a new property.

        Property(name, type, dims=None, unit=None, description=None)
            Creates a new property with the provided attributes.

        Property(seq)
            Creates a new property from sequence of 6 strings, corresponding to
            `name`, `type`, `dims`, `unit` and `description`.  Valid
            values for `dims` are:
              - '' or '[]': no dimensions
              - '<dim1>, <dim2>': list of dimension names
              - '[<dim1>, <dim2>]': list of dimension names


        """
        _dlite.Property_swiginit(self, _dlite.new_Property(name, type, dims, unit, description))
    __swig_destroy__ = _dlite.delete_Property

    def get_type(self) -> "char *":
        r"""get_type(self) -> char *"""
        return _dlite.Property_get_type(self)

    def get_dtype(self) -> "int":
        r"""get_dtype(self) -> int"""
        return _dlite.Property_get_dtype(self)

    def get_shape(self) -> "obj_t *":
        r"""get_shape(self) -> obj_t *"""
        return _dlite.Property_get_shape(self)

    def set_shape(self, arr: "obj_t *") -> "void":
        r"""set_shape(self, arr)"""
        return _dlite.Property_set_shape(self, arr)

    def __repr__(self):
        shape = ', shape=%r' % self.shape.tolist() if self.ndims else ''
        unit = ', unit=%r' % self.unit if self.unit else ''
        descr = ', description=%r' %self.description if self.description else ''
        return 'Property(%r, type=%r%s%s%s)' % (
            self.name, self.type, shape, unit, descr)

    def asdict(self, soft7=True, exclude_name=False):
        """Returns a dict representation of self.

        Args:
            soft7: Whether to use new SOFT7 format.
            exclude_name: Whether to exclude "name" from the returned dict.
        """
        d = OrderedDict()
        if not exclude_name:
            d['name'] = self.name
        d['type'] = self.get_type()
        if self.ndims:
            d['shape' if soft7 else 'dims'] = self.shape.tolist()
        if self.unit:
            d['unit'] = self.unit
        if self.description:
            d['description'] = self.description
        return d

    def asstrings(self):
        """Returns a representation of self as a tuple of strings."""
        return (self.name, self.type, ','.join(str(d) for d in self.shape),
                '' if self.unit is None else self.unit,
                '' if self.description is None else self.description)

    type = property(get_type, doc='Type name.')
    dtype = property(get_dtype, doc='Type number.')
    shape = property(get_shape, set_shape, doc='Array of dimension indices.')

    # Too be removed...
    def _get_dims_depr(self):
        warnings.warn('Property `dims` is deprecated, use `shape` instead.',
                      DeprecationWarning, stacklevel=2)
        return self.get_shape()
    dims = property(_get_dims_depr, doc='Array of dimension indices. '
                    'Property `dims` is deprecated, use `shape` instead.')



# Register Property in _dlite:
_dlite.Property_swigregister(Property)

class Relation(object):
    r"""Proxy of C _Triple struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    s = property(_dlite.Relation_s_get, _dlite.Relation_s_set, doc=r"""s""")
    p = property(_dlite.Relation_p_get, _dlite.Relation_p_set, doc=r"""p""")
    o = property(_dlite.Relation_o_get, _dlite.Relation_o_set, doc=r"""o""")
    id = property(_dlite.Relation_id_get, _dlite.Relation_id_set, doc=r"""id""")

    def __init__(self, s: "char const *", p: "char const *", o: "char const *", id: "char const *"=None):
        r"""__init__(self, s, p, o, id=None) -> Relation"""
        _dlite.Relation_swiginit(self, _dlite.new_Relation(s, p, o, id))
    __swig_destroy__ = _dlite.delete_Relation

    def __repr__(self):
        return 'Relation(s=%r, p=%r, o=%r, id=%r)' % (
            self.s, self.p, self.o, self.id)

    def aspreferred(self):
        """Returns preferred Python representation."""
        return self.asstrings()

    def asdict(self):
        """Returns a dict representation of self."""
        if self.id:
            d = OrderedDict(s=self.s, p=self.p, o=self.o, id=self.id)
        else:
            d = OrderedDict(s=self.s, p=self.p, o=self.o)
        return d

    def asstrings(self):
        """Returns a representation of self as a tuple of strings."""
        return (self.s, self.p, self.o)


# Register Relation in _dlite:
_dlite.Relation_swigregister(Relation)


def triple_get_id(s: "char const *", p: "char const *", o: "char const *", namespace: "char const *"=None) -> "char *":
    r"""triple_get_id(s, p, o, namespace=None) -> char *"""
    return _dlite.triple_get_id(s, p, o, namespace)

def triple_set_default_namespace(namespace: "char const *") -> "void":
    r"""triple_set_default_namespace(namespace)"""
    return _dlite.triple_set_default_namespace(namespace)
class Instance(object):
    r"""
    Returns a new instance.

    Instance(metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, dimensions=None, properties=None, description=None)
        Is called from one of the following class methods defined in dlite.py:

          - from_metaid(cls, metaid, dims, id=None)
          - from_url(cls, url, metaid=None)
          - from_storage(cls, storage, id=None, metaid=None)
          - from_location(cls, driver, location, options=None, id=None)
          - from_json(cls, jsoninput, id=None, metaid=None)
          - create_metadata(cls, uri, dimensions, properties, description)

          For details, see the documentation for the class methods.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    uuid = property(_dlite.Instance_uuid_get, doc=r"""uuid""")
    uri = property(_dlite.Instance_uri_get, doc=r"""uri""")
    _refcount = property(_dlite.Instance__refcount_get, doc=r"""_refcount""")

    def __init__(self, metaid: "char const *"=None, dims: "int *"=None, id: "char const *"=None, url: "char const *"=None, storage: "Storage"=None, driver: "char const *"=None, location: "char const *"=None, options: "char const *"=None, uri: "char const *"=None, jsoninput: "char const *"=None, dimensions: "Dimension"=None, properties: "Property"=None, description: "char const *"=None):
        r"""
        __init__(self, metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, uri=None, jsoninput=None, dimensions=None, properties=None, description=None) -> Instance
        Returns a new instance.

        Instance(metaid=None, dims=None, id=None, url=None, storage=None, driver=None, location=None, options=None, dimensions=None, properties=None, description=None)
            Is called from one of the following class methods defined in dlite.py:

              - from_metaid(cls, metaid, dims, id=None)
              - from_url(cls, url, metaid=None)
              - from_storage(cls, storage, id=None, metaid=None)
              - from_location(cls, driver, location, options=None, id=None)
              - from_json(cls, jsoninput, id=None, metaid=None)
              - create_metadata(cls, uri, dimensions, properties, description)

              For details, see the documentation for the class methods.


        """
        _dlite.Instance_swiginit(self, _dlite.new_Instance(metaid, dims, id, url, storage, driver, location, options, uri, jsoninput, dimensions, properties, description))
    __swig_destroy__ = _dlite.delete_Instance

    def _get_meta(self) -> "struct _DLiteInstance const *":
        r"""
        _get_meta(self) -> Instance
        Returns reference to metadata.
        """
        return _dlite.Instance__get_meta(self)

    def save(self, driver_or_url: "char const *"=None, location: "char const *"=None, options: "char const *"=None, storage: "Storage"=None) -> "void":
        r"""
        save(self, driver_or_url=None, location=None, options=None, storage=None)
        Saves this instance to url or storage.

        Call signatures:
            save(url)
            save(driver, location, options=None)
            save(storage=storage)

        """
        return _dlite.Instance_save(self, driver_or_url, location, options, storage)

    def save_to_url(self, url: "char const *") -> "void":
        r"""save_to_url(self, url)"""
        return _dlite.Instance_save_to_url(self, url)

    def save_to_storage(self, storage: "Storage") -> "void":
        r"""save_to_storage(self, storage)"""
        return _dlite.Instance_save_to_storage(self, storage)

    def get_dimensions(self) -> "obj_t *":
        r"""
        get_dimensions(self) -> obj_t *
        Returns array with dimension sizes.
        """
        return _dlite.Instance_get_dimensions(self)

    def get_dimension_size(self, name: "char const *") -> "int":
        r"""
        get_dimension_size(self, name) -> int
        Returns the size of dimension with given name or index.
        """
        return _dlite.Instance_get_dimension_size(self, name)

    def get_dimension_size_by_index(self, i: "int") -> "int":
        r"""get_dimension_size_by_index(self, i) -> int"""
        return _dlite.Instance_get_dimension_size_by_index(self, i)

    def get_property(self, name: "char const *") -> "obj_t *":
        r"""
        get_property(self, name) -> obj_t *
        Returns property with given name.
        """
        return _dlite.Instance_get_property(self, name)

    def get_property_by_index(self, i: "int") -> "obj_t *":
        r"""
        get_property_by_index(self, i) -> obj_t *
        Returns property with given index.
        """
        return _dlite.Instance_get_property_by_index(self, i)

    def set_property(self, name: "char const *", obj: "obj_t *") -> "void":
        r"""
        set_property(self, name, obj)
        Sets property with given name to `obj`.
        """
        return _dlite.Instance_set_property(self, name, obj)

    def set_property_by_index(self, i: "int", obj: "obj_t *") -> "void":
        r"""
        set_property_by_index(self, i, obj)
        Sets property with given index to `obj`.
        """
        return _dlite.Instance_set_property_by_index(self, i, obj)

    def get_property_as_string(self, name: "char const *", width: "int"=0, prec: "int"=-2, flags: "int"=0) -> "char *":
        r"""
        get_property_as_string(self, name, width=0, prec=-2, flags=0) -> char *
        Return property `name` as a string.

        `width`  Minimum field width. Unused if 0, auto if -1.
        `prec`   Precision. Auto if -1, unused if -2.
        `flags`  Or'ed sum of formatting flags:
            0  default (json)
            1  raw unquoted output
            2  quoted output
        """
        return _dlite.Instance_get_property_as_string(self, name, width, prec, flags)

    def set_property_from_string(self, name: "char const *", s: "char const *", flags: "int"=0) -> "void":
        r"""
        set_property_from_string(self, name, s, flags=0)
        Set property `name` to the value of string `s`. 

        `flags` is the or'ed sum of:
          0  default (json)
          1  raw unquoted input
          2  quoted input
          4  strip initial and final spaces
        """
        return _dlite.Instance_set_property_from_string(self, name, s, flags)

    def has_property(self, name: "char const *") -> "bool":
        r"""
        has_property(self, name) -> bool
        Returns true if this instance has a property with given name.
        """
        return _dlite.Instance_has_property(self, name)

    def has_property_by_index(self, i: "int") -> "bool":
        r"""
        has_property_by_index(self, i) -> bool
        Returns true if this instance has a property with given index.
        """
        return _dlite.Instance_has_property_by_index(self, i)

    def has_dimension(self, name: "char const *") -> "bool":
        r"""
        has_dimension(self, name) -> bool
        Returns true if this instance has a dimension with given name.
        """
        return _dlite.Instance_has_dimension(self, name)

    def has_dimension_by_index(self, i: "int") -> "bool":
        r"""
        has_dimension_by_index(self, i) -> bool
        Returns true if this instance has a dimension with given index.
        """
        return _dlite.Instance_has_dimension_by_index(self, i)

    def _is_data(self) -> "bool":
        r"""
        _is_data(self) -> bool
        Returns true if this is a data instance.
        """
        return _dlite.Instance__is_data(self)

    def _is_meta(self) -> "bool":
        r"""
        _is_meta(self) -> bool
        Returns true if this is metadata.
        """
        return _dlite.Instance__is_meta(self)

    def _is_metameta(self) -> "bool":
        r"""
        _is_metameta(self) -> bool
        Returns true if this is meta-metadata.
        """
        return _dlite.Instance__is_metameta(self)

    def _incref(self) -> "int":
        r"""
        _incref(self) -> int
        Increase reference count and return the new refcount.
        """
        return _dlite.Instance__incref(self)

    def _decref(self) -> "int":
        r"""
        _decref(self) -> int
        Decrease reference count and return the new refcount.
        """
        return _dlite.Instance__decref(self)

    def tojson(self, indent: "int"=0, flags: "int"=0) -> "char *":
        r"""tojson(self, indent=0, flags=0) -> char *"""
        return _dlite.Instance_tojson(self, indent, flags)

    def __len__(self) -> "int":
        r"""__len__(self) -> int"""
        return _dlite.Instance___len__(self)

    def __repr__(self) -> "char *":
        r"""__repr__(self) -> char *"""
        return _dlite.Instance___repr__(self)

    def _c_ptr(self) -> "PyObject *":
        r"""_c_ptr(self) -> PyObject *"""
        return _dlite.Instance__c_ptr(self)


        # Override default generated __init__() method
    def __init__(self, *args, **kwargs):
        if self is None:
            raise DLiteError(f"invalid dlite.Instance")

        dlite.errclr()
        _dlite.Instance_swiginit(self, _dlite.new_Instance(*args, **kwargs))

        if not hasattr(self, 'this') or not getattr(self, 'this'):
            raise DLiteError(f"cannot initiate dlite.Instance")
        elif self.is_meta:
            self.__class__ = Metadata
        elif self.meta.uri == COLLECTION_ENTITY:
            self.__class__ = Collection

    def get_meta(self):
        """Returns reference to metadata."""
        meta = self._get_meta()
        assert meta.is_meta
        meta.__class__ = Metadata
        return meta

    def get_property_descr(self, name):
        """Return a Property object for property `name`."""
        for p in self.meta['properties']:
            if p.name == name:
                return p
        raise ValueError(f'No property "{name}" in "{self.uri}"')

    meta = property(get_meta, doc="Reference to the metadata of this instance.")
    dimensions = property(
        lambda self: OrderedDict((d.name, int(v))
                                 for d, v in zip(self.meta['dimensions'],
                                                 self.get_dimensions())),
        doc='Dictionary with dimensions name-value pairs.')
    properties = property(lambda self:
        {p.name: self[p.name] for p in self.meta['properties']},
        doc='Dictionary with property name-value pairs.')
    is_data = property(_is_data, doc='Whether this is a data instance.')
    is_meta = property(_is_meta, doc='Whether this is a metadata instance.')
    is_metameta = property(_is_metameta,
                           doc='Whether this is a meta-metadata instance.')

    @classmethod
    def from_metaid(cls, metaid, dims, id=None):
        """Create a new instance of metadata `metaid`.  `dims` must be a
        sequence with the size of each dimension.  All values initialized
        to zero.  If `id` is None, a random UUID is generated.  Otherwise
        the UUID is derived from `id`.
        """
        if isinstance(dims, dict):
            meta = get_instance(metaid)
            dims = [dims[dim.name] for dim in meta.properties['dimensions']]
    # Allow metaid to be an Instance
        if isinstance(metaid, dlite.Instance):
            metaid = metaid.uri
        return Instance(
            metaid=metaid, dims=dims, id=id,
            dimensions=(), properties=()  # arrays must not be None
        )

    @classmethod
    def from_url(cls, url, metaid=None):
        """Load the instance from `url`.  The URL should be of the form
        ``driver://location?options#id``.
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        return Instance(
            url=url, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_storage(cls, storage, id=None, metaid=None):
        """Load the instance from `storage`.  `id` is the id of the instance
        in the storage (not required if the storage only contains more one
        instance).
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        return Instance(
            storage=storage, id=id, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_location(cls, driver, location, options=None, id=None):
        """Load the instance from storage specified by `driver`, `location`
        and `options`.  `id` is the id of the instance in the storage (not
        required if the storage only contains more one instance).
        """
        return Instance(
            driver=driver, location=str(location), options=options, id=id,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def from_json(cls, jsoninput, id=None, metaid=None):
        """Load the instance from storage specified by `driver`, `location`
        and `options`.  `id` is the id of the instance in the storage (not
        required if the storage only contains more one instance).
        """
        return Instance(
            jsoninput=jsoninput, id=id, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def create_metadata(cls, uri, dimensions, properties, description):
        """Create a new metadata entity (instance of entity schema) casted
        to an instance.
        """
        return Instance(
            uri=uri, dimensions=dimensions, properties=properties,
            description=description,
            dims=()  # arrays
        )

    @classmethod
    def create_from_metaid(cls, metaid, dims, id=None):
        """Create a new instance of metadata `metaid`.  `dims` must be a
        sequence with the size of each dimension.  All values initialized
        to zero.  If `id` is None, a random UUID is generated.  Otherwise
        the UUID is derived from `id`.
        """
        warnings.warn(
            "create_from_metaid() is deprecated, use from_metaid() instead.",
            DeprecationWarning, stacklevel=2)
        if isinstance(dims, dict):
            meta = get_instance(metaid)
            dims = [dims[dim.name] for dim in meta.properties['dimensions']]
        return Instance(
            metaid=metaid, dims=dims, id=id,
            dimensions=(), properties=()  # arrays must not be None
        )

    @classmethod
    def create_from_url(cls, url, metaid=None):
        """Load the instance from `url`.  The URL should be of the form
        ``driver://location?options#id``.
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        warnings.warn(
            "create_from_url() is deprecated, use from_url() instead.",
            DeprecationWarning, stacklevel=2)
        return Instance(
            url=url, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def create_from_storage(cls, storage, id=None, metaid=None):
        """Load the instance from `storage`.  `id` is the id of the instance
        in the storage (not required if the storage only contains more one
        instance).
        If `metaid` is provided, the instance is tried mapped to this
        metadata before it is returned.
        """
        warnings.warn(
            "create_from_storage() is deprecated, use from_storage() instead.",
            DeprecationWarning, stacklevel=2)
        return Instance(
            storage=storage, id=id, metaid=metaid,
            dims=(), dimensions=(), properties=()  # arrays
        )

    @classmethod
    def create_from_location(cls, driver, location, options=None, id=None):
        """Load the instance from storage specified by `driver`, `location`
        and `options`.  `id` is the id of the instance in the storage (not
        required if the storage only contains more one instance).
        """
        warnings.warn(
            "create_from_location() is deprecated, use from_location() "
            "instead.", DeprecationWarning, stacklevel=2)
        return Instance(
            driver=driver, location=str(location), options=options, id=id,
            dims=(), dimensions=(), properties=()  # arrays
        )

    def save(self, dest, location=None, options=None):
        """Saves this instance to url or storage.

        Call signatures:
          - save(url)
          - save(driver, location, options=None)
          - save(storage)
        """
        if isinstance(dest, Storage):
            self.save_to_storage(storage=dest)
        elif location:
            with Storage(dest, str(location), options) as storage:
                storage.save(self)
        elif isinstance(dest, str):
            self.save_to_url(dest)
        else:
            raise DLiteError('Arguments do not match any call signature')

    def __getitem__(self, ind):
        if isinstance(ind, int):
            return self.get_property_by_index(ind)
        elif self.has_property(ind):
            return self.get_property(ind)
        elif isinstance(ind, int):
            raise IndexError('instance property index out of range: %d' % ind)
        else:
            raise KeyError('no such property: %s' % ind)

    def __setitem__(self, ind, value):
        if isinstance(ind, int):
            self.set_property_by_index(ind, value)
        elif self.has_property(ind):
            self.set_property(ind, value)
        elif isinstance(ind, int):
            raise IndexError('instance property index out of range: %d' % ind)
        else:
            raise KeyError('no such property: %s' % ind)

    def __contains__(self, item):
        return item in self.properties.keys()

    def __getattr__(self, name):
        if name == 'this':
            return object.__getattribute__(self, name)
        d = object.__getattribute__(self, '__dict__')
        if name in d:
            return d[name]
        elif self.has_property(name):
            return _get_property(self, name)
        elif self.has_dimension(name):
            return self.get_dimension_size(name)
        else:
            raise AttributeError('Instance object has no attribute %r' % name)

    def __setattr__(self, name, value):
        if name == 'this':
            object.__setattr__(self, name, value)
        elif _has_property(self, name):
            _set_property(self, name, value)
        else:
            object.__setattr__(self, name, value)

    def __dir__(self):
        return (object.__dir__(self) +
                [name for name in self.properties] +
                [d.name for d in self.meta.properties['dimensions']])

    def __hash__(self):
        return UUID(self.uuid).int

    def __eq__(self, other):
        return self.uuid == other.uuid

    def __str__(self):
        return self.asjson(indent=2)

    def __reduce__(self):
    # ensures that instances can be pickled
        def iterfun(inst):
           for i, prop in enumerate(inst.properties.values()):
               if isinstance(prop, np.ndarray):
                   p = np.zeros_like(prop)
                   p.flat = [p.asdict() if hasattr(p, 'asdict') else p
                             for p in prop]
               else:
                   p = prop.asdict() if hasattr(prop, 'asdict') else prop
               yield i, p
        return (
            Instance.from_metaid,
            (self.meta.uri, list(self.dimensions.values()), self.uuid),
            None,
            None,
            iterfun(self),
        )

    def __call__(self, dims=(), id=None):
        """Returns an uninitiated instance of this metadata."""
        if not self.is_meta:
            raise TypeError('data instances are not callable')
        if isinstance(dims, dict):
            dims = [dims[d.name] for d in self.properties['dimensions']]
        return Instance.from_metaid(self.uri, dims, id)

    def asdict(self, soft7=True, uuid=True):
        """Returns a dict representation of self.

        Args:
            soft7: Whether to structure metadata as SOFT7.
            uuid: Whether to include UUID in the dict.
        """
        d = OrderedDict()
        if uuid:
            d['uuid'] = self.uuid
        if self.uri:
            d['uri'] = self.uri
        d['meta'] = self.meta.uri
        if self.is_meta:
    #d['name'] = self['name']
    #d['version'] = self['version']
    #d['namespace'] = self['namespace']
            d['description'] = self['description']
            if soft7:
                d['dimensions'] = {dim.name: dim.description
                                   for dim in self['dimensions']}
                d['properties'] = {p.name: p.asdict(exclude_name=True)
                                   for p in self['properties']}
            else:
                d['dimensions'] = [dim.asdict() for dim in self['dimensions']]
                d['properties'] = [p.asdict(soft7=False)
                                   for p in self['properties']]
        else:
            d['dimensions'] = self.dimensions
            d['properties'] = {k: standardise(v, self.get_property_descr(k))
                               for k, v in self.properties.items()}
        if self.has_property('relations') and (
                self.is_meta or self.meta.has_property('relations')):
            d['relations'] = self['relations'].tolist()
        return d

    def asjson(self, soft7=True, uuid=True, **kwargs):
        """Returns a JSON representation of self.  Arguments are passed to
        json.dumps()."""
        return json.dumps(self.asdict(soft7=soft7, uuid=uuid),
                          cls=InstanceEncoder, **kwargs)


# Register Instance in _dlite:
_dlite.Instance_swigregister(Instance)


def get_instance(id: "char const *", metaid: "char const *"=None, check_storages: "bool"=True) -> "struct _DLiteInstance *":
    r"""
    get_instance(id, metaid=None, check_storages=True) -> Instance
    Returns a new reference to instance with given id.

    If `metaid` is provided, the instance will be mapped to an instance of
    this metadata.

    If the instance exists in the in-memory store it is returned.
    Otherwise, if `check_storages` is true, the instance is searched for
    in the storage plugin path (initiated from the DLITE_STORAGES
    environment variable).

    It is an error message if the instance cannot be found.

    Note: seting `check_storages` to false is normally a good idea if calling
    this function from a storage plugin.  Otherwise you may easily end up in an
    infinite recursive loop that will exhaust the call stack.

    """
    return _dlite.get_instance(id, metaid, check_storages)

def has_instance(id: "char const *", check_storages: "bool"=True) -> "bool":
    r"""
    has_instance(id, check_storages=True) -> bool
    Returns whether an instance with `id` exists.

    If `check_storages` is true, the instance is also searched for
    in the storage plugin path.

    """
    return _dlite.has_instance(id, check_storages)

def istore_get_uuids() -> "char **":
    r"""
    istore_get_uuids() -> char **
    Returns a list of in-memory stored ids.


    """
    return _dlite.istore_get_uuids()

def _get_property(inst: "Instance", name: "char const *") -> "obj_t *":
    r"""_get_property(inst, name) -> obj_t *"""
    return _dlite._get_property(inst, name)

def _set_property(inst: "Instance", name: "char const *", obj: "obj_t *") -> "void":
    r"""_set_property(inst, name, obj)"""
    return _dlite._set_property(inst, name, obj)

def _has_property(inst: "Instance", name: "char const *") -> "bool":
    r"""_has_property(inst, name) -> bool"""
    return _dlite._has_property(inst, name)
BASIC_METADATA_SCHEMA = _dlite.BASIC_METADATA_SCHEMA

ENTITY_SCHEMA = _dlite.ENTITY_SCHEMA

COLLECTION_ENTITY = _dlite.COLLECTION_ENTITY


import sys
import json
import base64
import warnings

from uuid import UUID
if sys.version_info >= (3, 7):
    OrderedDict = dict
else:
    from collections import OrderedDict

import numpy as np


class InvalidMetadataError:
    """Malformed or invalid metadata."""


class InstanceEncoder(json.JSONEncoder):
    def default(self, obj):
        if isinstance(obj, (bytes, bytearray)):
            return obj.hex()
        elif isinstance(obj, np.ndarray):
            if obj.dtype.kind == 'V':
                conv = lambda e: ([conv(ele) for ele in e]
                                  if isinstance(e, list)
                                  else base64.b16encode(e))
                return conv(obj.tolist())
            else:
                return obj.tolist()
        elif hasattr(obj, 'aspreferred'):
            return obj.aspreferred()
        elif hasattr(obj, 'asdict'):
            return obj.asdict()
        elif hasattr(obj, 'asstrings'):
            return obj.asstrings()
        else:
            return json.JSONEncoder.default(self, obj)


class Metadata(Instance):
    """A subclass of Instance for metadata.

    Arguments:
        uri: URI of the new metadata.
        dimensions: Sequence of Dimension instances describing each dimension.
        properties: Sequence of Property instances describing each property.
        description: Description of metadata.
    """
    def __new__(
            cls,
            uri: str,
            dimensions: "Sequence[Dimension]",
            properties: "Sequence[Property]",
            description: str = ''
    ):
        return Instance.create_metadata(
            uri, dimensions, properties, description)

    def __repr__(self):
        return f"<Metadata: uri='{self.uri}'>"

    def getprop(self, name):
        """Returns the metadata property object with the given name."""
        if "properties" not in self.properties:
            raise InvalidMetadataError(
                'self.properties on metadata must contain a "properties" item'
            )
        lst = [p for p in self.properties["properties"] if p.name == name]
        if lst:
            return lst[0]
        raise DLiteError(f"Metadata {self.uri} has no such property: {name}")

    def dimnames(self):
        """Returns a list of all dimension names in this metadata."""
        if "dimensions" not in self.properties:
            return []
        return [d.name for d in self.properties['dimensions']]

    def propnames(self):
        """Returns a list of all property names in this metadata."""
        if "properties" not in self.properties:
            raise InvalidMetadataError(
                'self.properties on metadata must contain a "properties" item'
            )
        return [p.name for p in self.properties['properties']]


def standardise(v, prop, asdict=False):
    """Represent property value `v` as a standard python type.
    If `asdict` is true, dimensions, properties and relations will be
    represented with a dict, otherwise as a list of strings."""
    if asdict:
        conv = lambda x: x.asdict() if hasattr(x, 'asdict') else x
    else:
        conv = lambda x: list(x.asstrings()) if hasattr(x, 'asstrings') else x

    if prop.dtype == dlite.BlobType:
        if prop.ndims:
            V = np.fromiter(
                (''.join(f'{c:02x}' for c in s.item()) for s in v.flat),
                dtype=f'U{2*prop.size}')
            V.shape = v.shape
            return V.tolist()
        else:
            return ''.join(f'{c:02x}' for c in v)
    elif hasattr(v, 'tolist'):
        return [conv(x) for x in v.tolist()]
    else:
        return conv(v)


def get_instance(id: "str", metaid: "str"=None, check_storages: "bool"=True) -> "Instance":
    """Return instance with given id.

    Arguments:
        id: Id of instance to return.
        metaid: If given, dlite will try to convert the instance to a new
            instance of `metaid`.
        check_storages: Whether to check for the instance in storages listed
            in dlite.storage_path if the instance is not already in memory.

    Returns:
        DLite instance.
    """
    if isinstance(id, dlite.Instance):
        inst = id
    else:
        inst = _dlite.get_instance(id, metaid, check_storages)

    if inst is None:
        raise DLiteError(f"no such instance: {id}")
    elif inst.is_meta:
        inst.__class__ = Metadata
    elif inst.meta.uri == _dlite.COLLECTION_ENTITY:
        inst.__class__ = Collection
    return inst



def _collection_save(coll: "_Collection", s: "Storage") -> "int":
    r"""_collection_save(coll, s) -> int"""
    return _dlite._collection_save(coll, s)

def _collection_save_url(coll: "_Collection", url: "char const *") -> "int":
    r"""_collection_save_url(coll, url) -> int"""
    return _dlite._collection_save_url(coll, url)

def _collection_add_relation(coll: "_Collection", s: "char const *", p: "char const *", o: "char const *") -> "int":
    r"""_collection_add_relation(coll, s, p, o) -> int"""
    return _dlite._collection_add_relation(coll, s, p, o)

def _collection_remove_relations(coll: "_Collection", s: "char const *", p: "char const *", o: "char const *") -> "int":
    r"""_collection_remove_relations(coll, s, p, o) -> int"""
    return _dlite._collection_remove_relations(coll, s, p, o)

def _collection_find_first(coll: "_Collection", s: "char const *", p: "char const *", o: "char const *") -> "struct _Triple const *":
    r"""_collection_find_first(coll, s, p, o) -> Relation"""
    return _dlite._collection_find_first(coll, s, p, o)

def _collection_add(coll: "_Collection", label: "char const *", inst: "Instance") -> "int":
    r"""_collection_add(coll, label, inst) -> int"""
    return _dlite._collection_add(coll, label, inst)

def _collection_remove(coll: "_Collection", label: "char const *") -> "int":
    r"""_collection_remove(coll, label) -> int"""
    return _dlite._collection_remove(coll, label)

def _collection_get_new(coll: "_Collection", label: "char const *", metaid: "char const *") -> "struct _DLiteInstance *":
    r"""_collection_get_new(coll, label, metaid) -> Instance"""
    return _dlite._collection_get_new(coll, label, metaid)

def _collection_get_id(coll: "_Collection", id: "char const *") -> "struct _DLiteInstance const *":
    r"""_collection_get_id(coll, id) -> Instance"""
    return _dlite._collection_get_id(coll, id)

def _collection_has(coll: "_Collection", label: "char const *") -> "int":
    r"""_collection_has(coll, label) -> int"""
    return _dlite._collection_has(coll, label)

def _collection_has_id(coll: "_Collection", id: "char const *") -> "int":
    r"""_collection_has_id(coll, id) -> int"""
    return _dlite._collection_has_id(coll, id)

def _collection_count(coll: "_Collection") -> "int":
    r"""_collection_count(coll) -> int"""
    return _dlite._collection_count(coll)
class _Collection(object):
    r"""Proxy of C _DLiteCollection struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    uuid = property(_dlite._Collection_uuid_get, doc=r"""uuid""")
    uri = property(_dlite._Collection_uri_get, doc=r"""uri""")
    _refcount = property(_dlite._Collection__refcount_get, doc=r"""_refcount""")

    def __init__(self, url: "char const *"=None, storage: "Storage"=None, id: "char const *"=None, lazy: "bool"=False):
        r"""__init__(self, url=None, storage=None, id=None, lazy=False) -> _Collection"""
        _dlite._Collection_swiginit(self, _dlite.new__Collection(url, storage, id, lazy))
    __swig_destroy__ = _dlite.delete__Collection

    def asinstance(self) -> "struct _DLiteInstance *":
        r"""
        asinstance(self) -> Instance
        Returns a new view of collection as an instance.
        """
        return _dlite._Collection_asinstance(self)

# Register _Collection in _dlite:
_dlite._Collection_swigregister(_Collection)

class _CollectionIter(object):
    r"""Proxy of C _CollectionIter struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    coll = property(_dlite._CollectionIter_coll_get, _dlite._CollectionIter_coll_set, doc=r"""coll""")
    state = property(_dlite._CollectionIter_state_get, _dlite._CollectionIter_state_set, doc=r"""state""")
    s = property(_dlite._CollectionIter_s_get, _dlite._CollectionIter_s_set, doc=r"""s""")
    p = property(_dlite._CollectionIter_p_get, _dlite._CollectionIter_p_set, doc=r"""p""")
    o = property(_dlite._CollectionIter_o_get, _dlite._CollectionIter_o_set, doc=r"""o""")
    rettype = property(_dlite._CollectionIter_rettype_get, _dlite._CollectionIter_rettype_set, doc=r"""rettype""")

    def __init__(self, *args, **kwargs):
        r"""
        __init__(self, inst, s=None, p=None, o=None, rettype='T') -> _CollectionIter
        Iterator over instances in a collection.
        """
        _dlite._CollectionIter_swiginit(self, _dlite.new__CollectionIter(*args, **kwargs))
    __swig_destroy__ = _dlite.delete__CollectionIter

    def next(self) -> "struct _DLiteInstance const *":
        r"""
        next(self) -> Instance
        Returns a reference to next matching relation.
        """
        return _dlite._CollectionIter_next(self)

    def next_relation(self) -> "struct _Triple const *":
        r"""next_relation(self) -> Relation"""
        return _dlite._CollectionIter_next_relation(self)

    def poll(self) -> "struct _Triple const *":
        r"""
        poll(self) -> Relation
        Returns reference to the current instance or None if all instances have been visited.
        """
        return _dlite._CollectionIter_poll(self)

    def reset(self) -> "void":
        r"""
        reset(self)
        Resets the iterator.  The next call to next() will return the first relation.
        """
        return _dlite._CollectionIter_reset(self)

    def __iter__(self):
        return self

    def __next__(self):
        if self.rettype == 'I':
            v = self.next()
        elif self.rettype in 'RTspo':
            v = self.next_relation()
        else:
            raise ValueError('`rettype` must one of "IRTspo"')

        if v is None:
            raise StopIteration()

        if self.rettype == 'T':
            return (v.s, v.p, v.o)
        elif self.rettype == 's':
            return v.s
        elif self.rettype == 'p':
            return v.p
        elif self.rettype == 'o':
            return v.o
        return v


# Register _CollectionIter in _dlite:
_dlite._CollectionIter_swigregister(_CollectionIter)


def _get_collection(id: "char const *") -> "struct _DLiteCollection *":
    r"""
    _get_collection(id) -> _Collection
    Returns a new reference to a collection with given id.
    """
    return _dlite._get_collection(id)

from warnings import warn


class Collection(Instance):
    """A collection of instances and relations between them.

    Instances added to a collection are referred to with a label,
    which is local to the collection.

    Iteration over a collection will iterate over the instances added
    to it.  Likewise, the len() of a collection will return the number
    of instances.

    Use the get_relations() method (or the convenience methods
    get_subjects(), get_predicates() and get_predicates()) to iterate
    over relations.  The number of relations is available via the `nrelations`
    property.
    """
    def __new__(cls, id=None):
        """Creates an empty collection."""
        _coll = _Collection(id=id)
        inst = _coll.asinstance()
        inst.__class__ = Collection
        return inst

    def __init__(self, id=None):
        pass  # avoid calling Instance.__init__()

    @classmethod
    def load(cls, src, location=None, options=None, id=None, lazy=True):
        """Loads a collection from storage.

        Arguments:
            src: Storage instance | url | driver
            location: str
                File path to load from when `src` is a driver.
            options: str
                Options passed to the storage plugin when `src` is a driver.
            id: str
                Id of collection to load.  Needed if there are more than
                one instance in the storage.
            lazy: bool
                Whether to also save all instances referred to by the
                collection.
        """
        if isinstance(src, Storage):
            _coll = _Collection(storage=src, id=id, lazy=bool(lazy))
        elif location:
            with Storage(src, location, options) as s:
                _coll = _Collection(storage=s, id=id, lazy=bool(lazy))
        else:
            _coll = _Collection(url=src, lazy=bool(lazy))
        inst = _coll.asinstance()
        inst.__class__ = Collection
        return inst

    def save(self, dst, location=None, options=None, include_instances=True):
        """Save collection.

        Arguments:
            dst: Storage instance | url | driver
            location: str
                File path to write to when `dst` is a driver.
            options: str
                Options passed to the storage plugin when `dst` is a driver.
            include_instances: bool
                Whether to also save all instances referred to by the
                collection.
        """
        loc = str(location) if location else None
        if include_instances:
            c = self._coll
            if isinstance(dst, Storage):
                _collection_save(c, dst)
            elif location:
                with Storage(dst, loc, options) as s:
                    _collection_save(c, s)
            else:
                _collection_save_url(c, dst)
        elif isinstance(dst, Storage):
            Instance.save(self, storage=dst)
        else:
            Instance.save(self, dst, loc, options)

    _coll = property(
        lambda self: _get_collection(id=self.uuid),
        doc='SWIG-internal representation of this collection.')

    properties = property(
        lambda self: {'relations': list(self.get_relations())},
        doc='Dictionary with property name-value pairs.')

    def __repr__(self):
        return '<Collection: %s>' % (
            f"uri='{self.uri}'" if self.uri else f"uuid='{self.uuid}'")

    def __iter__(self):
        return _CollectionIter(self, rettype='I')

    def __len__(self):
        return _collection_count(self._coll)

    def __getitem__(self, label):
        return self.get(label)

    def __setitem__(self, label, inst):
        self.add(label, inst)

    def __delitem__(self, label):
        self.remove(label)

    def __contains__(self, label):
        return self.has(label)

    def add(self, label, inst, force=False):
        """Add `inst` to collection with given label.
        If `force` is true, a possible existing instance will be replaced.
        """
        if force and self.has(label):
            self.remove(label)
        _collection_add(self._coll, label, inst)

    def remove(self, label):
        """Remove instance with given label from collection."""
        if _collection_remove(self._coll, label):
            raise DLiteError(f'No such label in collection: "{label}"')

    def get(self, label, metaid=None):
        """Return instance with given label."""
        return _collection_get_new(self._coll, label, metaid)

    def get_id(self, id):
        """Return instance with given id."""
        inst = _collection_get_id(self._coll, id)
        return inst

    def has(self, label):
        """Returns true if an instance has been added with the given label."""
        b = _collection_has(self._coll, label)
        return bool(b)

    def has_id(self, id):
        """Returns true if an instance has been added with the given id."""
        b = _collection_has_id(self._coll, id)
        return bool(b)

    def add_relation(self, s, p, o):
        """Add (subject, predicate, object) RDF triple to collection."""
        if _collection_add_relation(self._coll, s, p, o) != 0:
            raise DLiteError(f'Error adding relation ({s}, {p}, {o})')

    def remove_relations(self, s=None, p=None, o=None):
        """Remove all relations matching `s`, `p` and `o`."""
        if _collection_remove_relations(self._coll, s, p, o) < 0:
            raise DLiteError(
                f'Error removing relations matching ({s}, {p}, {o})')

    def get_first_relation(self, s=None, p=None, o=None):
        """Returns the first relation matching `s`, `p` and `o`.
        None is returned if there are no matching relations."""
        return _collection_find_first(self._coll, s, p, o)

    def get_instances(self):
        """Returns a generator over all instances in collection."""
        return _CollectionIter(self, s=None, p=None, o=None, rettype='I')

    def get_labels(self):
        """Returns a generator over all labels."""
        return self.get_subjects(p='_is-a', o='Instance')

    def get_relations(self, s=None, p=None, o=None, rettype='T'):
        """Returns a generator over all relations matching the given
        values of `s`, `p` and `o`."""
        return _CollectionIter(self, s=s, p=p, o=o, rettype=rettype)

    def get_subjects(self, p=None, o=None):
        """Returns a generator over all subjects of relations matching the
        given values of `p` and `o`."""
        return _CollectionIter(self, s=None, p=p, o=o, rettype='s')

    def get_predicates(self, s=None, o=None):
        """Returns a generator over all predicates of relations matching the
        given values of `s` and `o`."""
        return _CollectionIter(self, s=s, p=None, o=o, rettype='p')

    def get_objects(self, s=None, p=None):
        """Returns a generator over all subjects of relations matching the
        given values of `s` and `p`."""
        return _CollectionIter(self, s=s, p=p, o=None, rettype='o')


def get_collection(id):
    """Returns a new reference to a collection with given id."""
    warn("dlite.get_collection() is deprecated.  "
         "Use dlite.get_instance() instead",
         DeprecationWarning, stacklevel=2)
    _coll = _get_collection(id=id)
    inst = _coll.asinstance()
    inst.__class__ = Collection
    return inst


class FUPath(object):
    r"""Proxy of C _FUPaths struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    n = property(_dlite.FUPath_n_get, doc=r"""n""")

    def __init__(self, pathtype: "char const *"):
        r"""
        __init__(self, pathtype) -> FUPath
        Creates a _Path instance of type `pathtype`.

        """
        _dlite.FUPath_swiginit(self, _dlite.new_FUPath(pathtype))
    __swig_destroy__ = _dlite.delete_FUPath

    def __repr__(self) -> "char *":
        r"""__repr__(self) -> char *"""
        return _dlite.FUPath___repr__(self)

    def __len__(self) -> "int":
        r"""__len__(self) -> int"""
        return _dlite.FUPath___len__(self)

    def getitem(self, index: "int") -> "char const *":
        r"""getitem(self, index) -> char const *"""
        return _dlite.FUPath_getitem(self, index)

    def __setitem__(self, index: "int", path: "char const *") -> "void":
        r"""__setitem__(self, index, path)"""
        return _dlite.FUPath___setitem__(self, index, path)

    def __delitem__(self, index: "int") -> "void":
        r"""__delitem__(self, index)"""
        return _dlite.FUPath___delitem__(self, index)

    def insert(self, index: "int", path: "char const *") -> "void":
        r"""insert(self, index, path)"""
        return _dlite.FUPath_insert(self, index, path)

    def append(self, path: "char const *") -> "void":
        r"""append(self, path)"""
        return _dlite.FUPath_append(self, path)

    def extend(self, paths: "char const *", pathsep: "char const *"=None) -> "void":
        r"""extend(self, paths, pathsep=None)"""
        return _dlite.FUPath_extend(self, paths, pathsep)

    def get_platform(self) -> "char const *":
        r"""get_platform(self) -> char const *"""
        return _dlite.FUPath_get_platform(self)

    def set_platform(self, platform: "char const *") -> "void":
        r"""set_platform(self, platform)"""
        return _dlite.FUPath_set_platform(self, platform)

    def __contains__(self, value):
        return value in self.aslist()

    def __getitem__(self, key):
        n = len(self)
        if key < 0:
            key += n
        if key < 0 or key >= n:
            raise IndexError(f'key out of range: {key}')
        return self.getitem(key)

    def aslist(self):
        return [self[i] for i in range(len(self))]



# Register FUPath in _dlite:
_dlite.FUPath_swigregister(FUPath)


storage_path = FUPath("storages")
storage_plugin_path = FUPath("storage-plugins")
mapping_plugin_path = FUPath("mapping-plugins")
python_storage_plugin_path = FUPath("python-storage-plugins")
python_mapping_plugin_path = FUPath("python-mapping-plugins")



def mapping(output_uri: "char const *", instances: "struct _DLiteInstance **") -> "struct _DLiteInstance *":
    r"""
    mapping(output_uri, instances) -> Instance
      Returns a new instance of metadata `output_uri` by mapping the
      input instances.

    """
    return _dlite.mapping(output_uri, instances)

def python_mapping_unload() -> "void":
    r"""
    python_mapping_unload()
      Unloads all currently loaded mappings.

    """
    return _dlite.python_mapping_unload()

def mapping_plugin_unload(name: "char const *"=None) -> "int":
    r"""mapping_plugin_unload(name=None) -> int"""
    return _dlite.mapping_plugin_unload(name)


